# pydantic-argparse-next

Argument parser based on pydantic v2.

### Supports:

- [x] Positional arguments
  
  - [x] Required positional arguments
  
  - [x] Optional positional arguments

- [x] Keyword arguments
  
  - [x] Required keyword arguments
  
  - [x] Optional keyword arguments

- [x] Subcommands
  
  - [x] Required subcommands
  
  - [x] Optional subcommands
  
  - [x] Subcommands within subcommands

- [x] Actions
  
  - [x] Choice (And simple text and Enum object)
  
  - [x] Store True
  
  - [x] Store False
  
  - [x] Variadic arguments

- [ ] Extra
  
  - [ ] Easy saving config to file
  
  - [ ] Easy load config from file

### Docs and examples:

1. [Base usage](./docs/BaseUsage.md)

2. Actions
   
   1. [Choice](./docs/Choice.md)
   
   2. [Store True and Store False](./docs/StoreTrueFalse.md)
   
   3. [Subcommands](./docs/Subcommans.md)
   
   4. [Variadic](./docs/Variadic.md)
